<?php
namespace Geral\Entities;

/**
 * @method findOneByNrloteestqAndCdfilialAndNrorgAndNrsubloteAndCdproduto($lote, $filial, $nrorg, $subLote, $cdProduto) static
 * @method \Geral\Repositories\Lote getRepository static
 */
class Lote extends Base\Lote
{

    CONST LIBERADO = 'L';
    CONST ENCERRADO = 'E';
    CONST INDISPONIVEL = 'I';

    CONST LOTEPADRAO = ' ';
    CONST SUBLOTEPADRAO = ' ';


    public function insereLote($filial, $nrorg, $cdProduto, $lote, $subLote, $status){
        /** @var $objFilial Filial */
        $objFilial = Filial::getObject(
            array(
                'cdfilial' => $filial,
                'nrorg' => $nrorg,
            )
        );

        /** @var $objProduto Produto */
        $objProduto = Produto::getObject(
            array(
                'cdproduto' => $cdProduto,
                'nrorg' => $nrorg,
            )
        );

        $this->setFilial($objFilial);
        $this->setProduto($objProduto);
        $this->setNrloteestq($lote);
        $this->setNrsublote($subLote);
        $this->setIdstatlote($status);
        $this->setDtentrlote(\Geral\Util\DateUtil::getDataAtual(true));

        $this->persist();
        return $this;
    }
}