/* Tabela ERROAVISONF: Erro e Aviso do Fechamento de NF(Nota Fiscal) */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ERROAVISONF */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Erro e Aviso do Fechamento de NF(Nota Fiscal),
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_ERROAVISONF
AFTER DELETE OR INSERT OR UPDATE
ON ERROAVISONF FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(300);
  V_DTOPER    DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.IDERROAVISO IS NOT NULL THEN
         V_DESC := V_DESC || 'Identificador Erro/Aviso = ' || :OLD.IDERROAVISO;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.CDERROAVISO;
   ELSE
      IF UPDATING THEN
         IF (:NEW.IDERROAVISO <> :OLD.IDERROAVISO) THEN
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDERROAVISO;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDERROAVISO;
      END IF;

      IF :NEW.IDERROAVISO IS NOT NULL THEN
         V_DESC := V_DESC || 'Identificador Erro/Aviso = ' || :NEW.IDERROAVISO;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('ERROAVISONF',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_ERROAVISONF','4.09.060'); END;
/
