/*
 TECNISA - TECNOLOGIA EM INFORMTICA

 NOME: CALCULO_MINBCPRODUTO

 DESCRIO:
  PROCEDIMENTO PARA CLCULO DA PAUTA MNIMA FISCAL PARA A BASE DE CLCULO DO PRODUTO.

 CRIAO:
 07/07/2004 - REJANE PRISCILA LEITE

 @C:\WIN_V4\SQL\END_CONV\ORACLE\5204_DFESTPO.SQL
 RAISE_APPLICATION_ERROR(-20501, '', TRUE);
*/

CREATE OR REPLACE PROCEDURE CALCULO_MINBCPRODUTO
(   P_CDEMPRESA       IN NOTAFISCAL.CDEMPRESA%TYPE,
    P_TIPOOPER        IN NOTAFISCAL.CDTIPOOPER%TYPE,
    P_CDINSCESTA      IN NOTAFISCAL.CDINSCESTA%TYPE,
    P_IDENTRSAID      IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
    P_CDPAIS          IN ESTADO.CDPAIS%TYPE,
    P_SGESTADO        IN ESTADO.SGESTADO%TYPE,
    P_CDPRODUTO       IN ITEMPRODUTO.CDPRODUTO%TYPE,
    P_GRUPOFISCAL     IN GRUPOFISCAL.CDGRUPOFISC%TYPE,
    P_DTENTRSAID      IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_NRLANCTONF      IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_CDFILIAL        IN NOTAFISCAL.CDFILIAL%TYPE,
    P_SEQUITPROD      IN ITEMPRODUTO.NRSEQITPROD%TYPE,
    P_VRPRODUTO     OUT NUMBER)
IS
   V_VRUNITARIO   NUMBER;
   V_QTITEMPROD   NUMBER;
   V_VRPAUTAMINBC NUMBER;
BEGIN
   BEGIN
      SELECT VRUNITITEM, QTITEMPROD
      INTO V_VRUNITARIO, V_QTITEMPROD
      FROM ITEMPRODUTO
      WHERE CDFILIAL    = P_CDFILIAL   AND
            NRLANCTONF  = P_NRLANCTONF AND
            NRSEQITPROD = P_SEQUITPROD;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRUNITARIO := 0;  V_QTITEMPROD := 0;
   END;

   IF P_GRUPOFISCAL IS NULL THEN
      BEGIN
         SELECT VRPRODUTOBC
         INTO V_VRPAUTAMINBC
         FROM VRPRODBCIMPO
         WHERE CDEMPRESA     = P_CDEMPRESA    AND
               IDENTRSAIDOP  = P_IDENTRSAID   AND
               CDTIPOOPER    = P_TIPOOPER     AND
               CDINSCESTA    = P_CDINSCESTA   AND
               CDPRODUTO     = P_CDPRODUTO    AND
               CDPAIS        = P_CDPAIS       AND
               SGESTADO      = P_SGESTADO     AND
               DTVALIDBCPR   = (SELECT MAX(DTVALIDBCPR)
                                FROM VRPRODBCIMPO
                                WHERE CDEMPRESA     = P_CDEMPRESA    AND
                                      IDENTRSAIDOP  = P_IDENTRSAID   AND
                                      CDTIPOOPER    = P_TIPOOPER     AND
                                      CDINSCESTA    = P_CDINSCESTA   AND
                                      CDPRODUTO     = P_CDPRODUTO    AND
                                      CDPAIS        = P_CDPAIS       AND
                                      SGESTADO      = P_SGESTADO     AND
                                      DTVALIDBCPR   <= P_DTENTRSAID  AND
                                      CDGRUPOFISC   IS NULL)              AND
               CDGRUPOFISC   IS NULL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRPAUTAMINBC := 0;
      END;
   ELSE
      BEGIN
         SELECT VRPRODUTOBC
         INTO V_VRPAUTAMINBC
         FROM VRPRODBCIMPO
         WHERE CDEMPRESA     = P_CDEMPRESA   AND
               IDENTRSAIDOP  = P_IDENTRSAID  AND
               CDTIPOOPER    = P_TIPOOPER    AND
               CDINSCESTA    = P_CDINSCESTA  AND
               CDPRODUTO     = P_CDPRODUTO   AND
               CDPAIS        = P_CDPAIS      AND
               SGESTADO      = P_SGESTADO    AND
               DTVALIDBCPR   = (SELECT MAX(DTVALIDBCPR)
                                FROM VRPRODBCIMPO
                                WHERE CDEMPRESA     = P_CDEMPRESA   AND
                                      IDENTRSAIDOP  = P_IDENTRSAID  AND
                                      CDTIPOOPER    = P_TIPOOPER    AND
                                      CDINSCESTA    = P_CDINSCESTA  AND
                                      CDPRODUTO     = P_CDPRODUTO   AND
                                      CDPAIS        = P_CDPAIS      AND
                                      SGESTADO      = P_SGESTADO    AND
                                      DTVALIDBCPR  <= P_DTENTRSAID  AND
                                      CDGRUPOFISC   = P_GRUPOFISCAL)       AND
               CDGRUPOFISC   = P_GRUPOFISCAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRPAUTAMINBC := 0;
      END;
   END IF;

   IF ROUND(V_VRUNITARIO,2) < ROUND(V_VRPAUTAMINBC,2) THEN
      P_VRPRODUTO := V_VRPAUTAMINBC * V_QTITEMPROD;
   ELSE
      P_VRPRODUTO := 0;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALCULO_MINBCPRODUTO','4.11.081'); END;
/

